Attribute VB_Name = "etsy"
Sub etsy()
Attribute etsy.VB_ProcData.VB_Invoke_Func = " \n14"
'
' etsy Macro
'

'

    Dim lr As Long
    lr = Range("A1", Range("A1").End(xlDown)).Cells.Count
    
'SPLIT TO COLUMNS AND ASSIGN IMPORTANT FORMATS
    'Range("K2:O" & lr).ClearFormats
    'Range("K2:O" & lr).NumberFormat = "0.00"
    
    
    Dim comOrSc As Range
    Set comOrSc = Range("A1").Find(",")
    If comOrSc Is Nothing Then
        Range("A1:A" & lr).Select
        Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=True, _
        Semicolon:=True, TrailingMinusNumbers:=True
    Else
        Range("A1:A" & lr).Select
        Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=True, _
        Comma:=True, TrailingMinusNumbers:=True
    End If

    
    Dim vr As Long
    vr = Range("A1:A" & lr).SpecialCells(xlCellTypeVisible).Cells.Count
      
    Range("A2:A" & lr).Select
    Selection.Replace What:=".", Replacement:="", _
    SearchOrder:=xlByColumns, MatchCase:=True
    Selection.NumberFormat = "dd.mm.yyyy"
      
    Range("F2:H" & lr).Select
    Selection.Replace What:="", Replacement:="", _
    SearchOrder:=xlByColumns, MatchCase:=True
    Selection.NumberFormat = "0.00"
           
    Range("C2:C" & lr).Select
    Selection.Replace What:="", Replacement:="", _
    SearchOrder:=xlByColumns, MatchCase:=True
    
    Range("C" & lr).Select
    
    ' Artikel SUM to last row
    Range("A" & lr + 1) = Range("A2").Value
    Range("A" & lr + 1).NumberFormat = "dd.mm.yyyy"
    Range("B" & lr + 1) = "Artikel"
    Range("C" & lr + 1) = "Gesamtsumme Gebhren Artikel"
    Range("E" & lr + 1) = "EUR"
    Range("F" & lr + 1) = Application.WorksheetFunction. _
    SumIf(Range("B2:B" & lr), "Artikel", Range("G2:G" & lr))
    lr = Range("A1", Range("A1").End(xlDown)).Cells.Count
    
    ' Transaktion SUM to last row
    Range("A" & lr + 1) = Range("A2").Value
    Range("A" & lr + 1).NumberFormat = "dd.mm.yyyy"
    Range("B" & lr + 1) = "Transaktion"
    Range("C" & lr + 1) = "Gesamtsumme Transaktionsgebhren Etsy"
    Range("E" & lr + 1) = "EUR"
    Range("F" & lr + 1) = Application.WorksheetFunction. _
    SumIf(Range("B2:B" & lr), "Transaktion", Range("G2:G" & lr))
    lr = Range("A1", Range("A1").End(xlDown)).Cells.Count
    
    ' Marketing SUM to last row
    Range("A" & lr + 1) = Range("A2").Value
    Range("A" & lr + 1).NumberFormat = "dd.mm.yyyy"
    Range("B" & lr + 1) = "Marketing"
    Range("C" & lr + 1) = "Gesamtsumme Transaktionsgebhren Etsy"
    Range("E" & lr + 1) = "EUR"
    Range("F" & lr + 1) = Application.WorksheetFunction. _
    SumIf(Range("B2:B" & lr), "Marketing", Range("G2:G" & lr))
    lr = Range("A1", Range("A1").End(xlDown)).Cells.Count
    
    ' Verkauf SUM to last row
    Range("A" & lr + 1) = Range("A2").Value
    Range("A" & lr + 1).NumberFormat = "dd.mm.yyyy"
    Range("B" & lr + 1) = "Verkauf"
    Range("C" & lr + 1) = "Processing Fees"
    Range("E" & lr + 1) = "EUR"
    Range("F" & lr + 1) = Application.WorksheetFunction. _
    SumIf(Range("B2:B" & lr), "Verkauf", Range("G2:G" & lr))
    
    'DELETE ROWS = "ARTIKEL" "MARKETING" "TRANSAKTION"
    lr = Cells(Rows.Count, 2).End(xlUp).Row
    Range("A1:H1").Select
    Selection.AutoFilter Field:=2, Criteria1:=Array("Artikel", "Marketing", "Transaktion"), Operator:=xlFilterValues
    Selection.AutoFilter Field:=6, Criteria1:="--"
    vr = Range("A1:A" & lr).SpecialCells(xlCellTypeVisible).Cells.Count
    If vr > 1 Then
    Range("A2:I" & lr).SpecialCells(xlCellTypeVisible).EntireRow.Delete
    End If
    
    
    Dim arr() As Variant
    Dim x As Long
    ReDim arr(2 To lr)
    vr = Range("A1:A" & lr).SpecialCells(xlCellTypeVisible).Cells.Count
    Dim dato As Long

    'For Loop to extract number from column "B"
       For x = 2 To lr
           arr(x) = Cells(x, 3).Value
           If arr(x) Like "#*" Then
               arr(x) = "-" & Left(arr(x), InStr(arr(x), " ") - 1)
               'Debug.Print arr(x)
               Cells(x, 6).ClearFormats
               Cells(x, 6).Value = arr(x)
               Cells(x, 6).NumberFormat = "0.00"
          End If
      Next x
    
     
    
    'Replace "--" with blank
    Range("A1:H1").AutoFilter Field:=2
    Range("A1:H1").AutoFilter Field:=6
    lr = Cells(Rows.Count, 2).End(xlUp).Row
    Range("A2:H" & lr).Replace What:="--", Replacement:=""
    
    vr = Range("A1:A" & lr).SpecialCells(xlCellTypeVisible).Cells.Count
    
    ' Change formulas by simple data in the whole sheet
    Cells.Select
    Selection.Copy
    Range("a1").PasteSpecial (xlPasteValues)
    Range("A1").Select
    Application.CutCopyMode = False
    
'    lr = Cells(Rows.Count, 2).End(xlUp).Row
'    Dim arr() As Variant
'    Dim i As Long
'    ReDim arr(2 To lr)
'    For i = 2 To lr
'        arr(i) = Range("F" & i).Value * 1
'        Range("F" & i) = arr(i)
'    Next i
    
    ' Rename column headers
    Range("A1") = "Buchungsdatum"
    Range("B1") = "Auftragsart"
    Range("C1") = "Empfnger/Zahlungsplichtiger"
    Range("D1") = "Verwendungszweck"
    Range("E1") = "Whrung"
    Range("F1") = "Betrag"
    Range("G1") = "Irrelevant"
    Range("H1") = "Irrelevant"
    
    'Delete irrelevant columns
    Dim mc As Long
    mc = ActiveSheet.UsedRange.Columns.Count

    For i = mc To 1 Step -1
        If ActiveSheet.Cells(1, i).Value = "Irrelevant" Then
           ActiveSheet.Cells(1, i).EntireColumn.Delete xlshiftleft
        End If
    Next i
    
    Range("A1").Select
    
End Sub
